// Generated by rstantools.  Do not edit by hand.

/*
    serosv is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    serosv is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with serosv.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_log_logistic_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 32> locations_array__ =
  {" (found before start of program)",
  " (in 'log_logistic', line 8, column 2 to column 29)",
  " (in 'log_logistic', line 9, column 2 to column 14)",
  " (in 'log_logistic', line 10, column 2 to column 27)",
  " (in 'log_logistic', line 11, column 2 to column 27)",
  " (in 'log_logistic', line 12, column 2 to column 17)",
  " (in 'log_logistic', line 13, column 2 to column 17)",
  " (in 'log_logistic', line 16, column 2 to column 29)",
  " (in 'log_logistic', line 17, column 2 to column 29)",
  " (in 'log_logistic', line 19, column 2 to column 38)",
  " (in 'log_logistic', line 20, column 2 to column 38)",
  " (in 'log_logistic', line 23, column 9 to column 13)",
  " (in 'log_logistic', line 23, column 2 to column 21)",
  " (in 'log_logistic', line 25, column 4 to column 56)",
  " (in 'log_logistic', line 24, column 20 to line 26, column 3)",
  " (in 'log_logistic', line 24, column 2 to line 26, column 3)",
  " (in 'log_logistic', line 29, column 4 to column 40)",
  " (in 'log_logistic', line 28, column 20 to line 30, column 3)",
  " (in 'log_logistic', line 28, column 2 to line 30, column 3)",
  " (in 'log_logistic', line 33, column 2 to column 43)",
  " (in 'log_logistic', line 34, column 2 to column 43)",
  " (in 'log_logistic', line 35, column 2 to column 32)",
  " (in 'log_logistic', line 36, column 2 to column 32)",
  " (in 'log_logistic', line 37, column 2 to column 37)",
  " (in 'log_logistic', line 38, column 2 to column 37)",
  " (in 'log_logistic', line 2, column 2 to column 20)",
  " (in 'log_logistic', line 3, column 9 to column 13)",
  " (in 'log_logistic', line 3, column 2 to column 19)",
  " (in 'log_logistic', line 4, column 8 to column 12)",
  " (in 'log_logistic', line 4, column 2 to column 32)",
  " (in 'log_logistic', line 5, column 8 to column 12)",
  " (in 'log_logistic', line 5, column 2 to column 30)"};
#include <stan_meta_header.hpp>
class model_log_logistic final : public model_base_crtp<model_log_logistic> {
private:
  int Nage;
  Eigen::Matrix<double,-1,1> age_data__;
  std::vector<int> posi;
  std::vector<int> ni;
  Eigen::Map<Eigen::Matrix<double,-1,1>> age{nullptr, 0};
public:
  ~model_log_logistic() {}
  model_log_logistic(stan::io::var_context& context__, unsigned int
                     random_seed__ = 0, std::ostream* pstream__ = nullptr)
      : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_log_logistic_namespace::model_log_logistic";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 25;
      context__.validate_dims("data initialization", "Nage", "int",
        std::vector<size_t>{});
      Nage = std::numeric_limits<int>::min();
      current_statement__ = 25;
      Nage = context__.vals_i("Nage")[(1 - 1)];
      current_statement__ = 25;
      stan::math::check_greater_or_equal(function__, "Nage", Nage, 1);
      current_statement__ = 26;
      stan::math::validate_non_negative_index("age", "Nage", Nage);
      current_statement__ = 27;
      context__.validate_dims("data initialization", "age", "double",
        std::vector<size_t>{static_cast<size_t>(Nage)});
      age_data__ = Eigen::Matrix<double,-1,1>::Constant(Nage,
                     std::numeric_limits<double>::quiet_NaN());
      new (&age) Eigen::Map<Eigen::Matrix<double,-1,1>>(age_data__.data(),
        Nage);
      {
        std::vector<local_scalar_t__> age_flat__;
        current_statement__ = 27;
        age_flat__ = context__.vals_r("age");
        current_statement__ = 27;
        pos__ = 1;
        current_statement__ = 27;
        for (int sym1__ = 1; sym1__ <= Nage; ++sym1__) {
          current_statement__ = 27;
          stan::model::assign(age, age_flat__[(pos__ - 1)],
            "assigning variable age", stan::model::index_uni(sym1__));
          current_statement__ = 27;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 28;
      stan::math::validate_non_negative_index("posi", "Nage", Nage);
      current_statement__ = 29;
      context__.validate_dims("data initialization", "posi", "int",
        std::vector<size_t>{static_cast<size_t>(Nage)});
      posi = std::vector<int>(Nage, std::numeric_limits<int>::min());
      current_statement__ = 29;
      posi = context__.vals_i("posi");
      current_statement__ = 29;
      stan::math::check_greater_or_equal(function__, "posi", posi, 0);
      current_statement__ = 30;
      stan::math::validate_non_negative_index("ni", "Nage", Nage);
      current_statement__ = 31;
      context__.validate_dims("data initialization", "ni", "int",
        std::vector<size_t>{static_cast<size_t>(Nage)});
      ni = std::vector<int>(Nage, std::numeric_limits<int>::min());
      current_statement__ = 31;
      ni = context__.vals_i("ni");
      current_statement__ = 31;
      stan::math::check_greater_or_equal(function__, "ni", ni, 0);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = 1 + 1 + 1 + 1 + 1 + 1;
  }
  inline std::string model_name() const final {
    return "model_log_logistic";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_log_logistic_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      local_scalar_t__ alpha1 = DUMMY_VAR__;
      current_statement__ = 1;
      alpha1 = in__.template read_constrain_lb<local_scalar_t__,
                 jacobian__>(0.00001, lp__);
      local_scalar_t__ alpha2 = DUMMY_VAR__;
      current_statement__ = 2;
      alpha2 = in__.template read<local_scalar_t__>();
      local_scalar_t__ tau_alpha1 = DUMMY_VAR__;
      current_statement__ = 3;
      tau_alpha1 = in__.template read_constrain_lb<local_scalar_t__,
                     jacobian__>(0, lp__);
      local_scalar_t__ tau_alpha2 = DUMMY_VAR__;
      current_statement__ = 4;
      tau_alpha2 = in__.template read_constrain_lb<local_scalar_t__,
                     jacobian__>(0, lp__);
      local_scalar_t__ mu_alpha1 = DUMMY_VAR__;
      current_statement__ = 5;
      mu_alpha1 = in__.template read<local_scalar_t__>();
      local_scalar_t__ mu_alpha2 = DUMMY_VAR__;
      current_statement__ = 6;
      mu_alpha2 = in__.template read<local_scalar_t__>();
      local_scalar_t__ sigma_alpha1 = DUMMY_VAR__;
      local_scalar_t__ sigma_alpha2 = DUMMY_VAR__;
      current_statement__ = 9;
      sigma_alpha1 = stan::math::sqrt((1 / tau_alpha1));
      current_statement__ = 10;
      sigma_alpha2 = stan::math::sqrt((1 / tau_alpha2));
      current_statement__ = 7;
      stan::math::check_greater_or_equal(function__, "sigma_alpha1",
        sigma_alpha1, 0);
      current_statement__ = 8;
      stan::math::check_greater_or_equal(function__, "sigma_alpha2",
        sigma_alpha2, 0);
      {
        current_statement__ = 11;
        stan::math::validate_non_negative_index("theta", "Nage", Nage);
        Eigen::Matrix<local_scalar_t__,-1,1> theta =
          Eigen::Matrix<local_scalar_t__,-1,1>::Constant(Nage, DUMMY_VAR__);
        current_statement__ = 15;
        for (int i = 1; i <= Nage; ++i) {
          current_statement__ = 13;
          stan::model::assign(theta,
            stan::math::inv_logit((alpha2 + (alpha1 *
              stan::math::log(
                stan::model::rvalue(age, "age", stan::model::index_uni(i)))))),
            "assigning variable theta", stan::model::index_uni(i));
        }
        current_statement__ = 18;
        for (int i = 1; i <= Nage; ++i) {
          current_statement__ = 16;
          lp_accum__.add(stan::math::binomial_lpmf<propto__>(
                           stan::model::rvalue(posi, "posi",
                             stan::model::index_uni(i)),
                           stan::model::rvalue(ni, "ni",
                             stan::model::index_uni(i)),
                           stan::model::rvalue(theta, "theta",
                             stan::model::index_uni(i))));
        }
        current_statement__ = 19;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(alpha1, mu_alpha1,
                         sigma_alpha1));
        current_statement__ = 20;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(alpha2, mu_alpha2,
                         sigma_alpha2));
        current_statement__ = 21;
        lp_accum__.add(stan::math::gamma_lpdf<propto__>(tau_alpha1, 0.01,
                         0.01));
        current_statement__ = 22;
        lp_accum__.add(stan::math::gamma_lpdf<propto__>(tau_alpha2, 0.01,
                         0.01));
        current_statement__ = 23;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(mu_alpha1, 0,
                         stan::math::sqrt(10000)));
        current_statement__ = 24;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(mu_alpha2, 0,
                         stan::math::sqrt(10000)));
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_log_logistic_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      double alpha1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 1;
      alpha1 = in__.template read_constrain_lb<local_scalar_t__,
                 jacobian__>(0.00001, lp__);
      double alpha2 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 2;
      alpha2 = in__.template read<local_scalar_t__>();
      double tau_alpha1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 3;
      tau_alpha1 = in__.template read_constrain_lb<local_scalar_t__,
                     jacobian__>(0, lp__);
      double tau_alpha2 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 4;
      tau_alpha2 = in__.template read_constrain_lb<local_scalar_t__,
                     jacobian__>(0, lp__);
      double mu_alpha1 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 5;
      mu_alpha1 = in__.template read<local_scalar_t__>();
      double mu_alpha2 = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 6;
      mu_alpha2 = in__.template read<local_scalar_t__>();
      double sigma_alpha1 = std::numeric_limits<double>::quiet_NaN();
      double sigma_alpha2 = std::numeric_limits<double>::quiet_NaN();
      out__.write(alpha1);
      out__.write(alpha2);
      out__.write(tau_alpha1);
      out__.write(tau_alpha2);
      out__.write(mu_alpha1);
      out__.write(mu_alpha2);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      current_statement__ = 9;
      sigma_alpha1 = stan::math::sqrt((1 / tau_alpha1));
      current_statement__ = 10;
      sigma_alpha2 = stan::math::sqrt((1 / tau_alpha2));
      current_statement__ = 7;
      stan::math::check_greater_or_equal(function__, "sigma_alpha1",
        sigma_alpha1, 0);
      current_statement__ = 8;
      stan::math::check_greater_or_equal(function__, "sigma_alpha2",
        sigma_alpha2, 0);
      if (emit_transformed_parameters__) {
        out__.write(sigma_alpha1);
        out__.write(sigma_alpha2);
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ alpha1 = DUMMY_VAR__;
      current_statement__ = 1;
      alpha1 = in__.read<local_scalar_t__>();
      out__.write_free_lb(0.00001, alpha1);
      local_scalar_t__ alpha2 = DUMMY_VAR__;
      current_statement__ = 2;
      alpha2 = in__.read<local_scalar_t__>();
      out__.write(alpha2);
      local_scalar_t__ tau_alpha1 = DUMMY_VAR__;
      current_statement__ = 3;
      tau_alpha1 = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, tau_alpha1);
      local_scalar_t__ tau_alpha2 = DUMMY_VAR__;
      current_statement__ = 4;
      tau_alpha2 = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, tau_alpha2);
      local_scalar_t__ mu_alpha1 = DUMMY_VAR__;
      current_statement__ = 5;
      mu_alpha1 = in__.read<local_scalar_t__>();
      out__.write(mu_alpha1);
      local_scalar_t__ mu_alpha2 = DUMMY_VAR__;
      current_statement__ = 6;
      mu_alpha2 = in__.read<local_scalar_t__>();
      out__.write(mu_alpha2);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "alpha1", "double",
        std::vector<size_t>{});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "alpha2", "double",
        std::vector<size_t>{});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "tau_alpha1",
        "double", std::vector<size_t>{});
      current_statement__ = 4;
      context__.validate_dims("parameter initialization", "tau_alpha2",
        "double", std::vector<size_t>{});
      current_statement__ = 5;
      context__.validate_dims("parameter initialization", "mu_alpha1",
        "double", std::vector<size_t>{});
      current_statement__ = 6;
      context__.validate_dims("parameter initialization", "mu_alpha2",
        "double", std::vector<size_t>{});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      local_scalar_t__ alpha1 = DUMMY_VAR__;
      current_statement__ = 1;
      alpha1 = context__.vals_r("alpha1")[(1 - 1)];
      out__.write_free_lb(0.00001, alpha1);
      local_scalar_t__ alpha2 = DUMMY_VAR__;
      current_statement__ = 2;
      alpha2 = context__.vals_r("alpha2")[(1 - 1)];
      out__.write(alpha2);
      local_scalar_t__ tau_alpha1 = DUMMY_VAR__;
      current_statement__ = 3;
      tau_alpha1 = context__.vals_r("tau_alpha1")[(1 - 1)];
      out__.write_free_lb(0, tau_alpha1);
      local_scalar_t__ tau_alpha2 = DUMMY_VAR__;
      current_statement__ = 4;
      tau_alpha2 = context__.vals_r("tau_alpha2")[(1 - 1)];
      out__.write_free_lb(0, tau_alpha2);
      local_scalar_t__ mu_alpha1 = DUMMY_VAR__;
      current_statement__ = 5;
      mu_alpha1 = context__.vals_r("mu_alpha1")[(1 - 1)];
      out__.write(mu_alpha1);
      local_scalar_t__ mu_alpha2 = DUMMY_VAR__;
      current_statement__ = 6;
      mu_alpha2 = context__.vals_r("mu_alpha2")[(1 - 1)];
      out__.write(mu_alpha2);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"alpha1", "alpha2", "tau_alpha1",
                "tau_alpha2", "mu_alpha1", "mu_alpha2"};
    if (emit_transformed_parameters__) {
      std::vector<std::string> temp{"sigma_alpha1", "sigma_alpha2"};
      names__.reserve(names__.size() + temp.size());
      names__.insert(names__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{},
                std::vector<size_t>{}, std::vector<size_t>{},
                std::vector<size_t>{}, std::vector<size_t>{},
                std::vector<size_t>{}};
    if (emit_transformed_parameters__) {
      std::vector<std::vector<size_t>>
        temp{std::vector<size_t>{}, std::vector<size_t>{}};
      dimss__.reserve(dimss__.size() + temp.size());
      dimss__.insert(dimss__.end(), temp.begin(), temp.end());
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "alpha1");
    param_names__.emplace_back(std::string() + "alpha2");
    param_names__.emplace_back(std::string() + "tau_alpha1");
    param_names__.emplace_back(std::string() + "tau_alpha2");
    param_names__.emplace_back(std::string() + "mu_alpha1");
    param_names__.emplace_back(std::string() + "mu_alpha2");
    if (emit_transformed_parameters__) {
      param_names__.emplace_back(std::string() + "sigma_alpha1");
      param_names__.emplace_back(std::string() + "sigma_alpha2");
    }
    if (emit_generated_quantities__) {}
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    param_names__.emplace_back(std::string() + "alpha1");
    param_names__.emplace_back(std::string() + "alpha2");
    param_names__.emplace_back(std::string() + "tau_alpha1");
    param_names__.emplace_back(std::string() + "tau_alpha2");
    param_names__.emplace_back(std::string() + "mu_alpha1");
    param_names__.emplace_back(std::string() + "mu_alpha2");
    if (emit_transformed_parameters__) {
      param_names__.emplace_back(std::string() + "sigma_alpha1");
      param_names__.emplace_back(std::string() + "sigma_alpha2");
    }
    if (emit_generated_quantities__) {}
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"tau_alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"tau_alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu_alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu_alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma_alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"sigma_alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"tau_alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"tau_alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu_alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"mu_alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"},{\"name\":\"sigma_alpha1\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"},{\"name\":\"sigma_alpha2\",\"type\":{\"name\":\"real\"},\"block\":\"transformed_parameters\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = (((((1 + 1) + 1) + 1) + 1) + 1);
    const size_t num_transformed = emit_transformed_parameters * ((1 + 1));
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = (((((1 + 1) + 1) + 1) + 1) + 1);
    const size_t num_transformed = emit_transformed_parameters * ((1 + 1));
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_log_logistic_namespace::model_log_logistic;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_log_logistic_namespace::profiles__;
}
#endif
#endif
